package com.vandyo.sentry.core.cases;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.vandyo.sentry.core.collectionMachine.CollectionMachine;
import com.vandyo.sentry.core.dto.Res;
import com.vandyo.sentry.core.tools.Signature;

import java.util.HashMap;
import java.util.Map;

public class LoginCase extends Case {

    private String mobile;
    private String pwd;

    public static final String loginUrl = "/user/authorize/pwd/login";

    public LoginCase(String mobile, String pwd) {
        this.mobile = mobile;
        this.pwd = pwd;
    }

    @Override
    public Res<Map<String, String>> check() {
        Map<String, String> data = new HashMap<>();
//        data.put("mobile", "18623414467");
        data.put("mobile", mobile);
//        data.put("password", "5f83f54fb34e2eed0439d37d80f5b1a3");
        data.put("password", pwd);
        HttpResponse response = HttpRequest.post(Signature.host + loginUrl)
                .body(JSONUtil.parseFromMap(data).toString()).execute();
        Res<Map<String, String>> res = new Res<>();
        if (response.isOk()) {
            JSONObject json = JSONUtil.parseObj(response.body());
            JSONObject resultJson = json.getJSONObject("result");
            String sid = resultJson.getStr("sid");
            String uid = resultJson.getStr("uid");
            res.setUId(uid);
            res.setSId(sid);
            res.setSuccess(true);
        } else {
            res.setKey(loginUrl);
            res.setSuccess(false);
            res.setStatus(Signature.matchStatus(response.getStatus()));
        }
        CollectionMachine.post(res);
        return res;
    }
}
